lemonade
=========
[![Build Status](https://travis-ci.org/runlevel3/lemonade.png)](https://travis-ci.org/runlevel3/lemonade)
[![Dependency Status](https://gemnasium.com/runlevel3/lemonade.png)](https://gemnasium.com/runlevel3/lemonade)
[![NPM version](https://badge.fury.io/js/lemonade.png)](http://badge.fury.io/js/lemonade)

Jump to [documentation](https://github.com/runlevel3/lemonade/wiki/)

## api framework
Lemonade is a nodejs framework designed to be used for backend apis. Emphasis is put on software adaptors, logging and communication via a serialized (jsoned) objects.

## abstract wrappers
Access to different software is essential when building a backend api. Lemonade tries to provide access to multiple software using abstract wrappers. No hassle about choosing an adaptor or refactoring parts of your application once an adaptor changes.

Adaptors built into lemonade : [mysql](https://github.com/runlevel3/lemonade/wiki/mysql), [cassandra](https://github.com/runlevel3/lemonade/wiki/cassandra), [rabbitmq](https://github.com/runlevel3/lemonade/wiki/rabbitmq), [solr](https://github.com/runlevel3/lemonade/wiki/solr)

Custom adaptors can be easily built or existing ones overloaded : [creating and overloading links](https://github.com/runlevel3/lemonade/wiki/links)

## built in daemons
Lemonade comes with built in [http daemon](https://github.com/runlevel3/lemonade/wiki/httpd) and [spinner daemon](https://github.com/runlevel3/lemonade/wiki/spinner) (crontab).

## simple mvc structure
Application logic is structured on the mvc model. [Controllers](https://github.com/runlevel3/lemonade/wiki/mvc#controllers) should handle input data and [models](https://github.com/runlevel3/lemonade/wiki/mvc#models) will be used to interact with the internal adaptors.

## graceful shutdown and restart
All daemons and adaptors are built with unload methods, so a graceful application shutdown and restart can be initiated at any time (sigterms can be used) : [shutdown](https://github.com/runlevel3/lemonade/wiki/shutdown)

## source file supervising
Lemonade can be started using the --watch-changes option. This will launch a watcher on the application directory which will gracefully restart the app once the sources change.

## standardized object structure and inclusion
All objects are overloaded when created with references to the main object (kernel) and to the instance object (if present). Objects can be created as singletons.                            
                            
## documentation
* [process flow](https://github.com/runlevel3/lemonade/wiki/flow)
* [getting started](https://github.com/runlevel3/lemonade/wiki/getting-started)
* [including files, creating objects](https://github.com/runlevel3/lemonade/wiki/including-files)
* [application mvc](https://github.com/runlevel3/lemonade/wiki/mvc)
* [links](https://github.com/runlevel3/lemonade/wiki/links)
  * [mysql](https://github.com/runlevel3/lemonade/wiki/mysql)
  * [solr](https://github.com/runlevel3/lemonade/wiki/solr)
  * [cassandra](https://github.com/runlevel3/lemonade/wiki/cassandra)
  * [rabbitmq](https://github.com/runlevel3/lemonade/wiki/rabbitmq)
* daemons
  * [httpd](https://github.com/runlevel3/lemonade/wiki/httpd)
  * [spinner](https://github.com/runlevel3/lemonade/wiki/spinner)
* [kernel](https://github.com/runlevel3/lemonade/wiki/kernel)


