/******************************************************************************
 * Lemonade JS
 * https://lemonadejs.com
 *
 * ----
 *
 * Dummy link loader
 *
 *****************************************************************************/

function dummyLoader() {}

/**
 * When the link is attached to the kernel, it is
 * initialized using the load method
 * @param {function} cb
 */
dummyLoader.prototype.load = function(cb) {
    cb(null, 'dummy alive');
};

/**
 * The kernel link. Should return the object the link is
 * created for.
 *
 * Ex : in config.js you link 'foo' : 'dummy' in runlevel
 * boot or run and then you can access in any module
 * this.kernel.foo and receive the dummy object
 */
dummyLoader.prototype.link = function() {};

/**
 * Method used when the kernel gathers statuses from all
 * loaded links
 */
dummyLoader.prototype.status = function () {};

/**
 * When the kernel goes into runlevel shutdown it will try
 * to gracefully unload all links by calling the respective
 * unload method on each
 */
dummyLoader.prototype.unload = function(cb) {
    cb(null, 'dummy dead');
};

/**
 * Exports
 */
exports = module.exports = dummyLoader;